/*
   CrAsm82.c:
   Source file to create Crasm82.dll
   Assembly Studio plug-in to output an Asm program to a .82p file
   Compiled with Visual C++ 5.0

   (c) 1999 Jeremy Goetsch and Eric Piel
   modified from Asm86.c
*/

#include <stdio.h>
#include <string.h>

/* note that windows routines are used only for the About command */
#include <windows.h>
#include <winuser.h>

__declspec(dllexport) const char *GetPluginDescription()
{
	return("Ti-82 CrASH program (.82p) file");
}

__declspec(dllexport) void About()
{
	MessageBox( NULL,
		"Ti-82 CrASH program (.82p) file export\n"
		"Assembly Studio plugin\n"
		"(c) 1999 Jeremy Goetsch and Eric Piel",
		"About CrAsm82.dll", MB_OK);
}

__declspec(dllexport) int SavePrgmFile(unsigned char *pData, unsigned nLength, const char *szFilename, char *szExt)
{
	FILE *out;
	unsigned i, wdval;
	unsigned checksum = 0x100;//0
	unsigned nCodeLength;
	char *p, pbuff[511];//128:why so small?

	/* add extension to filename and open file */
	strcpy(pbuff, szFilename);
	strcat(pbuff, ".82p");
	if ((out = fopen(pbuff, "wb")) == NULL)
		return(0);

	fwrite("**TI82**\x1a\x0a", 1, 11, out);
	fwrite("CrASH assembly program created with Asmide", 1, 42, out);

	nCodeLength = nLength + 3;
	wdval = nCodeLength + 17;
	fwrite(&wdval, 2, 1, out);	/* length to end of file */
	wdval = 0x000b;
	fwrite(&wdval, 2, 1, out);	/* always 0b,00 */
	checksum += wdval;
	wdval = nCodeLength + 2;
	fwrite(&wdval, 2, 1, out);	/* length of code + checksum */
	checksum += (wdval & 0x00FF) + (wdval>>8);
	wdval = 0x06;
	fwrite(&wdval, 1, 1, out);	/* program type */
	checksum += wdval;

	/* get program name */ 
	strncpy(pbuff, "\xdc",8);		// Must add the a (0xDC)
	if (!(p = strrchr(szFilename, '\\')))
		strncat(pbuff, szFilename, 7);
	else 
		strncat(pbuff, p + 1, 7);
	pbuff[8] = '\0';
	fwrite(pbuff, 1, 8, out);
	for (i = 0; i < 8; i++)
		checksum += pbuff[i];

	wdval = nCodeLength + 2;
	fwrite(&wdval, 2, 1, out);	/* length of code + checksum */
	checksum += (wdval & 0x00FF) + (wdval>>8);
	wdval = nCodeLength;
	fwrite(&wdval, 2, 1, out);	/* length of code */
	checksum += (wdval & 0x00FF) + (wdval>>8);

	wdval = 0xd5;			//
	fwrite(&wdval, 1, 1, out);	//
	wdval = 0x1100;			//CrASH header
	fwrite(&wdval, 2, 1, out);	//
	checksum += 0x11 + 0xd5;	//

	/* actual assembly code */
	fwrite(pData, 1, nLength, out);
	for (i = 0; i < nLength; i++)
		checksum += pData[i];
	fwrite(&checksum, 2, 1, out);

	/* return given extension */
	if (szExt != NULL)
		strcpy(szExt, ".82p");
	return(1);
}
